/********************************************************************************************************
 * PROGRAM      : FreeGo4
 * DATE - TIME  : dimanche 30 juillet 2006 - 13h19
 * AUTHOR       : Azevedo Filipe aka Nox PasNox ( pasnox at gmail dot com )
 * FILENAME     : Options.cpp
 * LICENSE      : GPL
 * COMMENTARY   : 
 ********************************************************************************************************/
#include "Options.h"
#include "main.h"
//
#include <QDir>
//
QPointer<Options> Options::mSelf = 0L;
//
Options* Options::current()
{
	if ( !mSelf )
		mSelf = new Options;
	return mSelf;
}
//
QString Options::settingsPath()
{
	QString p = QDir::homePath().append( "/.%1" ).arg( PROGRAM_NAME );
	QDir d( p );
	if ( !d.exists() )
	{
		if ( d.mkpath( p ) )
			return p;
	}
	else
		return p;
	return QDir::homePath();
}
//
void createFilesPrefix( QDir& d, const QString& p, const QString& pr )
{
	d.cd( p );
	//
	QString f;
	QFileInfoList files = d.entryInfoList();
	for ( int i = 0; i < files.count(); i++ )
	{
		if ( files[i].isFile() )
		{
			f = Options::settingsPath().append( QString( "/%1/%2" ).arg( pr, files[i].fileName() ) );
			if ( !QFile::exists( f ) )
			{
				QDir d2( Options::settingsPath().append( QString( "/%1" ).arg( pr ) ) );
				d2.mkpath( d2.path() );
				QFile::copy( files[i].absoluteFilePath(), f );
			}
		}
		else if ( files[i].isDir() )
			createFilesPrefix( d, files[i].absoluteFilePath(), pr );
	}
}
//
void Options::createFiles( const QString& p )
{
	QDir d( QString( ":/%1" ).arg( p ) );
	createFilesPrefix( d, d.path(), p );
}
//
QString Options::getFile( const QString& p, const QString& f )
{
	QString s = settingsPath().append( QString( "/%1/%2" ).arg( p, QFileInfo( f ).fileName() ) );
	if ( QFile::exists( s ) )
		return s;
	return f;
}
//
Options::Options( QObject* p )
	: QSettings( QString( "%1/%2.ini" ).arg( settingsPath(), PROGRAM_NAME ), QSettings::IniFormat, p )
{}
