/********************************************************************************************************
* PROGRAM      : FreeGo4
* DATE - TIME  : mardi 01 ao�t 2006 - 18h30
* AUTHOR       : Azevedo Filipe aka Nox PasNox ( pasnox at gmail dot com )
* FILENAME     : ThreadMailChecker.h
* LICENSE      : GPL
* COMMENTARY   : 
********************************************************************************************************/
#ifndef THREADMAILCHECKER_H
#define THREADMAILCHECKER_H

#include <QThread>
#include <QPointer>
#include <QSet>

class QTcpSocket;

struct EmailAccount
{
	QString Login;
	QString Password;
	QString Server;
};

typedef QSet<EmailAccount*> EmailAccounts;

class ThreadMailChecker : public QThread
{
	Q_OBJECT

public:
	static ThreadMailChecker* self();
	void run();

private:
	void closeSocket();
	bool writeToSocket( const QString& );
	bool readLineFromSocket( QByteArray& );
	int checkInbox( const QString&, const QString& );

	QTcpSocket* mSocket;
	EmailAccounts accounts;
	static QPointer<ThreadMailChecker> mSelf;

signals:
	void alert( const QString& );
	void newEmails( const QString&, int );
};

#endif // THREADMAILCHECKER_H
