/********************************************************************************************************
* PROGRAM      : FreeGo4
* DATE - TIME  : dimanche 30 juillet 2006 - 13h04
* AUTHOR       : Azevedo Filipe aka Nox PasNox ( pasnox at gmail dot com )
* FILENAME     : misc.h
* LICENSE      : GPL
* COMMENTARY   : 
********************************************************************************************************/
#ifndef MISC_H
#define MISC_H
//
#include <QUrl>
#include <QHash>
#include <QTextEdit>
//
enum ConnexionFreeBox
{
	FreeBoxTotal = 0,
	FreeBoxNDI,
	FreeBoxIP,
	FreeBoxIPTotal
};
//
struct FreeAccount
{
	FreeAccount( const QString& l = QString::null, const QString& p = QString::null, ConnexionFreeBox c = (ConnexionFreeBox)-1 )
		: Login( l ), Password( p ), Connexion( c )
	{}
	bool isValid()
	{
		if ( Login.isEmpty() || Password.isEmpty() || Connexion == -1 )
			return false;
		return true;
	}
	QString Login;
	QString Password;
	ConnexionFreeBox Connexion;
};
Q_DECLARE_METATYPE( FreeAccount );
//
struct Proxy
{
	Proxy( bool b = false, const QString& h = QString::null, int i = -1, const QString& l = QString::null, const QString& p = QString::null )
		: Enabled( b ), Host( h ), Port( i ), Login( l ), Password( p )
	{}
	bool Enabled;
	QString Host;
	int Port;
	QString Login;
	QString Password;
};
//
namespace misc
{
	QString encrypt( const QString& );
	QString decrypt( const QString& );
	QString euro();
	//
	void wait( int );
	bool openUrl( const QUrl& );
	//
	FreeAccount identify();
	void setCurrentFreeAccount( const QString& );
	Proxy proxy();
	//
	int emailAccountId( const QString& );
	void emailAddAccount( const QString&, const QString&, const QString& );
	void emailRemoveAccount( const QString& );
	QStringList emailAccounts();
	//
	int freeAccountId( const QString& );
	void freeAddAccount( const QString&, const QString&, ConnexionFreeBox );
	void freeRemoveAccount( const QString& );
	QStringList freeAccounts();
	QList<FreeAccount> freeAccountsList();
	//
	void openMailBox( const QString& );
	//
	QByteArray processLinks( const QByteArray& buffer, const QString& color = "#FFFFFF" );
	void setAutoStart( bool );
	//
	QHash<QString, QString> parseHTMLTag( const QString& tag );
	QList<QHash<QString, QString> > parseHTMLSelect( const QString& select );
	QString toPlainText( const QString& html );
	QList<QStringList> parseHtmlTable( const QString& table, bool plainText = true );
	QTextEdit* debugInTextEdit( const QString& string = QString::null, QTextEdit* edit = 0 );
}
//
#endif  // MISC_H
