/********************************************************************************************************
	* PROGRAM      : FreeGo4
	* DATE - TIME  : mardi 25 juillet 2006 - 22h56
	* AUTHOR       : Azevedo Filipe aka Nox PasNox ( pasnox gmail.com )
	* FILENAME     : pHTTPRequest.h
	* LICENSE      : GPL
	* COMMENTARY   : 
	********************************************************************************************************/
#ifndef PHTTPREQUEST_H
#define PHTTPREQUEST_H
//
#include <QHttp>
#include <QUrl>
#include <QTemporaryFile>
#include <QPointer>
#include <QHash>
//
class pRequest;
//
class pHttpRequest : public QHttp
{
	Q_OBJECT
	//
public:
	enum RequestType { rtSettings = 0, rtFile, rtByteArray, rtDomDocument };
	static pHttpRequest* self( QObject* = 0 );
	//
	int requestUrl( QObject*, const char*, QUrl, const QString& = "GET", pHttpRequest::RequestType = pHttpRequest::rtSettings, const QByteArray& data = QByteArray() );
	int requestUrl( QUrl url, const QString& method = "GET", const QByteArray& data = QByteArray() );
	//
	QString freeLoginUrl() const { return mFreeLoginUrl; }
	QString freeBaseUrl() const { return mFreeBaseUrl; }
	QString freeGoBaseUrl() const { return mFreeGoBaseUrl; }
	QString freeSSLBaseUrl() const { return mFreeSSLBaseUrl; }
	QString id() const { return mId; }
	QString idt() const { return mIdt; }
	//
private:
	pHttpRequest( QObject* = 0 );
	static QPointer<pHttpRequest> mSelf;
	QHash<int,pRequest> mRequests;
	int mIdLogin;
	QString mFreeBaseUrl, mFreeLoginUrl, mFreeGoBaseUrl, mId, mIdt, mFreeSSLBaseUrl;
	//
public slots:
	void login( QObject*, const char*, QString = QString::null, QString = QString::null );
	//
private slots:
	void sslErrors( const QList<QSslError>& errors );
	void requestFinished( int id, bool error );
	//
signals:
	void customRequestFinished( int id, bool error, QIODevice* device );
};
//
struct pRequest
{
	pRequest( QObject* o = 0, const char* s = 0, const QUrl& u = QUrl(), QTemporaryFile* f = 0, pHttpRequest::RequestType t = pHttpRequest::rtSettings )
		: sender( o ), slot( s ), url( u ), file( f ), type( t )
	{};
	//
	QPointer<QObject> sender;
	const char* slot;
	QUrl url;
	QPointer<QTemporaryFile> file;
	pHttpRequest::RequestType type;
};
//
#endif // PHTTPREQUEST_H
