/********************************************************************************************************
* PROGRAM      : FreeGo4
* DATE - TIME  : jeudi 27 juillet 2006 - 19h52
* AUTHOR       : Azevedo Filipe aka Nox PasNox ( pasnox at gmail dot com )
* FILENAME     : UILineFeature.cpp
* LICENSE      : GPL
* COMMENTARY   : 
********************************************************************************************************/
#include "UILineFeature.h"
#include "main.h"
#include "misc.h"
#include "XmlReader.h"
//
#include <QShowEvent>
#include <QSettings>
#include <QHeaderView>
//
QPointer<UILineFeature> UILineFeature::mSelf = 0L;
//
UILineFeature* UILineFeature::self( QWidget* p )
{
	if ( !mSelf )
		mSelf = new UILineFeature( p );
	return mSelf;
}
//
UILineFeature::UILineFeature( QWidget* p )
	: fgDialog( p )
{
	setupUi( this );
	fixMacWidgets();
	// change mode
	switch ( misc::identify().Connexion )
	{
		case FreeBoxTotal:
			changeMode( dmSagem );
			break;
		case FreeBoxNDI:
		case FreeBoxIP:
		case FreeBoxIPTotal:
			changeMode( dmSagem );
			break;
	}
	REQUESTER->login( this, "readLogin" );
}
//
void UILineFeature::showEvent( QShowEvent* e )
{
	fgDialog::showEvent( e );
	//
	twLineFeature->setItemHidden( twLineFeature->headerItem(), true );
	twLineFeature->header()->resizeSection( 0, 120 );
	twLineFeature->header()->resizeSection( 1, ( twLineFeature->width() -120 ) / 2 );
	twLineFeature->setVerticalScrollBarPolicy( Qt::ScrollBarAlwaysOff );
	twLineFeature->setHorizontalScrollBarPolicy( Qt::ScrollBarAlwaysOff );
}
//
void UILineFeature::changeMode( const DialogMode& m )
{
	switch ( m )
	{
		case dmSagem:
			setBackgroundPixmap( QPixmap( ":/caracteristiques/Pictures/caracteristiques/caracteristiques01.png" ) );
			break;
		case dmFreeBox:
			setBackgroundPixmap( QPixmap( ":/caracteristiques/Pictures/caracteristiques/caracteristiques02.png" ) );
			break;
	}
	fgClose->move( width() -( fgClose->width() +5 ), 4 );
	setWidgetTransparent( twLineFeature, backgroundPixmap() );
}
//
void UILineFeature::readLogin( QSettings*, bool b )
{
	if ( b )
	{
		UIMAIN->alert( "Impossible de vous identifier sur free, annulation" );
		deleteLater();
		return;
	}
	REQUESTER->requestUrl( this, "readLineFeature", REQUESTER->freeBaseUrl().append( "carac.php" ), "GET", pHttpRequest::rtDomDocument );
}
//
void UILineFeature::readLineFeature( const QDomDocument& document, bool error )
{
	if ( error )
	{
		UIMAIN->alert( "Impossible de telecharger le fichier carac.php" );
		return;
	}
	
	/*
		<caracteristique>
		* <ligne></ligne>
		* <offre></offre>
		* <telfbx></telfbx>
		* <adresseip></adresseip>
		<passerelle></passerelle>
		* <nra></nra>
		* <longueur></longueur>
		* <affaiblissement></affaiblissement>
		* <persodns></persodns>
		<ipv6></ipv6>
		</caracteristique>
	*/
	
	lFTLine2->setText( XmlReader::readPath( document, "caracteristique/ligne" ) );
	lOffer2->setText( XmlReader::readPath( document, "caracteristique/offre" ) );
	lNRA2->setText( XmlReader::readPath( document, "caracteristique/nra" ) );
	lLonger2->setText( XmlReader::readPath( document, "caracteristique/longueur" ) );
	lAffaiblissement2->setText( XmlReader::readPath( document, "caracteristique/affaiblissement" ) );
	lFreeBoxLine2->setText( XmlReader::readPath( document, "caracteristique/telfbx" ) );
	lIP2->setText( XmlReader::readPath( document, "caracteristique/adresseip" ) );
	lDNS2->setText( XmlReader::readPath( document, "caracteristique/persodns" ) );
	lIPV6_2->setText( XmlReader::readPath( document, "caracteristique/ipv6" ) );
}
