/********************************************************************************************************
* PROGRAM      : FreeGo4
* DATE - TIME  : jeudi 24 ao�t 2006 - 20h00
* AUTHOR       : Azevedo Filipe aka Nox PasNox ( pasnox at gmail dot com )
* FILENAME     : UINetwork.cpp
* LICENSE      : GPL
* COMMENTARY   : 
********************************************************************************************************/
#include "UINetwork.h"
#include "main.h"
#include "misc.h"
//
#include <QFile>
//
QPointer<UINetwork> UINetwork::mSelf = 0L;
//
UINetwork* UINetwork::self( QWidget* p )
{
	if ( !mSelf )
		mSelf = new UINetwork( p );
	return mSelf;
}
//
UINetwork::UINetwork( QWidget* p )
	: fgDialog( p )
{
	setupUi( this );
	fixMacWidgets();
	setWidgetTransparent( tbNetwork, backgroundPixmap() );
	setWidgetTransparent( tbFree, backgroundPixmap() );
	setWidgetTransparent( tbFreebox, backgroundPixmap() );
	REQUESTER->requestUrl( this, "readNetwork", REQUESTER->freeGoBaseUrl().append( "icoreseaufree/etatre.txt" ), "GET", pHttpRequest::rtFile );
	REQUESTER->requestUrl( this, "readFree", REQUESTER->freeGoBaseUrl().append( "icoreseaufree/nouvfree.txt" ), "GET", pHttpRequest::rtFile );
	REQUESTER->requestUrl( this, "readFreebox", REQUESTER->freeGoBaseUrl().append( "icoreseaufree/majfbx.txt" ), "GET", pHttpRequest::rtFile );
}
//
void UINetwork::readNetwork( const QString& s, bool b )
{
	const QString m = QString::fromUtf8( "Impossible de récupérer les informations de l'état du réseau Free auprès du serveur." );
	if ( b )
	{
		UIMAIN->alert( m );
		return;
	}
	QFile f( s );
	if ( f.open( QFile::ReadOnly | QFile::Text ) )
	{
		QString t = QString( f.readAll() ).replace( "\n", "<BR>" );
		tbNetwork->setHtml( t ); // misc::processLinks( t )
	}
	else
		UIMAIN->alert( m );
}
//
void UINetwork::readFree( const QString& s, bool b )
{
	const QString m = QString::fromUtf8( "Impossible de récupérer les informations des nouveautés Free auprès du serveur." );
	if ( b )
	{
		UIMAIN->alert( m );
		return;
	}
	QFile f( s );
	if ( f.open( QFile::ReadOnly | QFile::Text ) )
	{
		QString t = QString( f.readAll() ).replace( "\n", "<BR>" );
		tbFree->setHtml( t ); // misc::processLinks( t )
	}
	else
		UIMAIN->alert( m );
}
//
void UINetwork::readFreebox( const QString& s, bool b )
{
	const QString m = QString::fromUtf8( "Impossible de récupérer les informations des mises à jour Freebox auprès du serveur." );
	if ( b )
	{
		UIMAIN->alert( m );
		return;
	}
	QFile f( s );
	if ( f.open( QFile::ReadOnly | QFile::Text ) )
	{
		QString t = QString( f.readAll() ).replace( "\n", "<BR>" );
		tbFreebox->setHtml( t ); // misc::processLinks( t )
	}
	else
		UIMAIN->alert( m );
}
//
void UINetwork::anchorClicked( const QUrl& u )
{
	QTextBrowser* b = qobject_cast<QTextBrowser*>( sender() );
	b->setHtml( b->toHtml() );
	misc::openUrl( u );
}
