/********************************************************************************************************
* PROGRAM      : FreeGo4
* DATE - TIME  : jeudi 24 aot 2006 - 22h15
* AUTHOR       : Azevedo Filipe aka Nox PasNox ( pasnox at gmail dot com )
* FILENAME     : UIPhone.cpp
* LICENSE      : GPL
* COMMENTARY   : 
********************************************************************************************************/
#include "UIPhone.h"
#include "main.h"
#include "misc.h"

#include <QShowEvent>
#include <QHeaderView>
#include <QHBoxLayout>
#include <QFileDialog>
#include <QPushButton>
#include <QSound>

#include "XmlReader.h"

QPointer<UIPhone> UIPhone::mSelf = 0L;
QNetworkAccessManager DownloadMessageBox::manager;

pAction::pAction( QWidget* p )
	: QWidget( p )
{
	fgDialog::fixMacWidgets( this );
	QHBoxLayout* l = new QHBoxLayout( this );
	l->setMargin( 0 );
	l->setSpacing( 0 );
	l->setAlignment( Qt::AlignHCenter );
	//
	mPlay = new fgLabel;
	mPlay->setCursor( Qt::PointingHandCursor );
	mPlay->setButtonNormalPixmap( QPixmap( ":/principale/Pictures/principale/btn-fleche01.png" ) );
	l->addWidget( mPlay );
	//
	l->addSpacing( 5 );
	//
	mDelete = new fgLabel;
	mDelete->setCursor( Qt::PointingHandCursor );
	mDelete->setButtonNormalPixmap( QPixmap( ":/telephonie/Pictures/telephonie/off.png" ) );
	l->addWidget( mDelete );
}

DownloadMessageBox::DownloadMessageBox( const QString & fichier, QObject * parent )
	: QObject( parent )
{
	QNetworkRequest req( fichier );
	QNetworkReply * reply = manager.get( req );
	connect( reply, SIGNAL( finished() ), this, SLOT( onFinished() ) );
}

void DownloadMessageBox::onFinished()
{
	QNetworkReply * reply = qobject_cast< QNetworkReply * >( sender() );
	if(	reply )
	{
		QFile f( "tmp.wav" );
		f.open( QFile::WriteOnly );
		f.write( reply->readAll() );
		f.close();
		QSound::play( "tmp.wav" );
	}
	
	emit terminated();
}

UIPhone* UIPhone::self( QWidget* p )
{
	if ( !mSelf )
		mSelf = new UIPhone( p );
	return mSelf;
}

UIPhone::UIPhone( QWidget* p )
	: fgDialog( p ), mInit( false )
{
	setupUi( this );
	fixMacWidgets();
	pServices->setEnabled( false );
	pMessagerie->setEnabled( false );
	pFaxResume->setEnabled( false );
	pFaxNotification->setEnabled( false );
	//
	pfgResultat->setVisible( false );
	
	//
	setWidgetTransparent( leCode, pfgServices->buttonNormalPixmap() );
	setWidgetTransparent( leNumeroNonReponse, pfgServices->buttonNormalPixmap() );
	setWidgetTransparent( leDelaiNonReponse, pfgServices->buttonNormalPixmap() );
	setWidgetTransparent( leNumeroOccupation, pfgServices->buttonNormalPixmap() );
	setWidgetTransparent( leNumeroInconditionnel, pfgServices->buttonNormalPixmap() );
	setWidgetTransparent( leDelaiRenvoi, pfgServices->buttonNormalPixmap() );
	//
	setWidgetTransparent( twMessages, pfgMessagerie->buttonNormalPixmap() );
	setWidgetTransparent( leNotification1, pfgMessagerie->buttonNormalPixmap() );
	setWidgetTransparent( leNotification2, pfgMessagerie->buttonNormalPixmap() );
	setWidgetTransparent( leNotification3, pfgMessagerie->buttonNormalPixmap() );
	setWidgetTransparent( leNotification4, pfgMessagerie->buttonNormalPixmap() );
	//
	setWidgetTransparent( leNom, pfgAnnuaire->buttonNormalPixmap() );
	setWidgetTransparent( lePrenom, pfgAnnuaire->buttonNormalPixmap() );
	setWidgetTransparent( leVille, pfgAnnuaire->buttonNormalPixmap() );
	setWidgetTransparent( leCP, pfgAnnuaire->buttonNormalPixmap() );
	setWidgetTransparent( leDept, pfgAnnuaire->buttonNormalPixmap() );
	setWidgetTransparent( leNumFreebox, pfgAnnuaire->buttonNormalPixmap() );
	setWidgetTransparent( teResultat, pfgResultat->buttonNormalPixmap() );
	//
	setWidgetTransparent( leDestinataire, pfgEnvoiFax->buttonNormalPixmap() );
	setWidgetTransparent( leFichier, pfgEnvoiFax->buttonNormalPixmap() );
	//
	setWidgetTransparent( teFaxRecus, pfgFaxResume->buttonNormalPixmap() );
	setWidgetTransparent( teFaxEnvoyes, pfgFaxResume->buttonNormalPixmap() );
	//
	setWidgetTransparent( teFaxNotification, pfgFaxNotification->buttonNormalPixmap() );
	setWidgetTransparent( leAdresse, pfgFaxNotification->buttonNormalPixmap() );
	//
	manager = new QNetworkAccessManager( this );
	
	///
	QStringList items;
	items 	<< "Aucune"
			<< "Notification simple par email"
			<< QString::fromUtf8( "Fichier son envoyé en attachement" );
	
	cbNotification1->addItems( items );
	cbNotification2->addItems( items );
	cbNotification3->addItems( items );
	cbNotification4->addItems( items );
	///
	
	REQUESTER->login( this, "readLogin" );
}

void UIPhone::showEvent( QShowEvent* e )
{
	fgDialog::showEvent( e );
	//
	if ( !mInit )
	{
		mInit = true;
	}
}

void UIPhone::on_swRight_currentChanged( int i )
{
	fgServices->setPixmap( fgServices->buttonNormalPixmap() );
	fgMessagerie->setPixmap( fgMessagerie->buttonNormalPixmap() );
	fgAnnuaire->setPixmap( fgAnnuaire->buttonNormalPixmap() );
	fgEnvoiFax->setPixmap( fgEnvoiFax->buttonNormalPixmap() );
	fgFaxResume->setPixmap( fgFaxResume->buttonNormalPixmap() );
	fgNotificationFax->setPixmap( fgNotificationFax->buttonNormalPixmap() );
	
	switch ( i )
	{
	case 0:
		fgServices->setPixmap( fgServices->buttonPushedPixmap() );
		//
		REQUESTER->requestUrl( this, "readService", REQUESTER->freeBaseUrl().append( "https/admsrv.php" ), "GET", pHttpRequest::rtByteArray );
		pServices->setEnabled( false );
		break;
	case 1:
		fgMessagerie->setPixmap( fgMessagerie->buttonPushedPixmap() );
		//
		REQUESTER->requestUrl( this, "readNotification", REQUESTER->freeBaseUrl().append( "notification_tel.php" ), "GET", pHttpRequest::rtByteArray );
		pMessagerie->setEnabled( false );
		break;
	case 2:
		fgAnnuaire->setPixmap( fgAnnuaire->buttonPushedPixmap() );
		break;
	case 3:
		fgEnvoiFax->setPixmap( fgEnvoiFax->buttonPushedPixmap() );
		break;
	case 4:
		fgFaxResume->setPixmap( fgFaxResume->buttonPushedPixmap() );
		//
		REQUESTER->requestUrl( this, "readEnvoyesRecus", REQUESTER->freeBaseUrl().append( "tel_fax.php" ), "GET", pHttpRequest::rtByteArray );
		pFaxResume->setEnabled( false );
		break;
	case 5:
		fgNotificationFax->setPixmap( fgNotificationFax->buttonPushedPixmap() );
		//
		REQUESTER->requestUrl( this, "readNotifFax", REQUESTER->freeBaseUrl().append( "tel_notif_fax.php" ), "GET", pHttpRequest::rtByteArray );
		pFaxNotification->setEnabled( false );
		break;
	}
}

void UIPhone::readNotifFax( const QByteArray& buffer, bool error )
{
	if ( error )
	{
		UIMAIN->alert( QString( "An error occurs getting file: %1" ).arg( REQUESTER->freeBaseUrl().append( "tel_notif_fax.php" ) ) );
		return;
	}
	
	QDomDocument e( "FreeNotifications" );
	e.setContent( buffer );
	QDomElement root = e.firstChildElement( "notifmailfax" );
	
	// clear textedit
	teFaxNotification->clear();
	teFaxNotification->setColumnWidth( 0, 35 );
	teFaxNotification->setColumnWidth( 1, 380 );
	teFaxNotification->setColumnWidth( 2, 14 );
	
	QDomElement emails = root.firstChildElement( "email" );
	int pos = 0;
	while( !emails.isNull() )
	{
		pos++;
		QTreeWidgetItem * treeItem = new QTreeWidgetItem( teFaxNotification );
		treeItem->setText( 0, QString::number( pos ) );
		treeItem->setTextAlignment( 0, Qt::AlignHCenter );
		treeItem->setText( 1, emails.attribute( "contact" ) );
		
		pAction* action = new pAction;
		action->mPlay->hide();
		action->mDelete->setToolTip( emails.attribute( "del" ) );
		teFaxNotification->setItemWidget( treeItem, 2, action );
		// connections
		connect( action->mDelete, SIGNAL( clicked() ), this, SLOT( deleteClicked() ) );
		
		emails = emails.nextSiblingElement( "email" );
	}
	
	pFaxNotification->setEnabled( true );
}

void UIPhone::readEnvoyesRecus( const QByteArray& buffer, bool error )
{
	if ( error )
	{
		UIMAIN->alert( QString( "An error occurs getting file: %1" ).arg( REQUESTER->freeBaseUrl().append( "tel_fax.php" ) ) );
		return;
	}
	
	QDomDocument e( "FreeNotifications" );
	e.setContent( QString::fromLatin1( buffer.data() ) );
	
	QDomElement root = e.firstChildElement( "gestionfax" );
	
	/////////// RECUS ///////////
	// clear tree
	teFaxRecus->clear();
	teFaxRecus->setColumnWidth( 0, 100 );
	teFaxRecus->setColumnWidth( 1, 50 );
	teFaxRecus->setColumnWidth( 2, 95 );
	teFaxRecus->setColumnWidth( 3, 115 );
	teFaxRecus->setColumnWidth( 4, 35 );
	teFaxRecus->setColumnWidth( 5, 60 );
	
	QDomElement recus = root.firstChildElement( "recus" ).firstChildElement( "fax" );
	while( !recus.isNull() )
	{
		QTreeWidgetItem * treeItem = new QTreeWidgetItem( teFaxRecus );
		treeItem->setText( 0, recus.attribute( "fichier" ) );
		treeItem->setText( 1, recus.attribute( "pages" ) );
		treeItem->setTextAlignment( 1, Qt::AlignHCenter );
		treeItem->setText( 2, recus.attribute( "exp" ) );
		treeItem->setTextAlignment( 2, Qt::AlignHCenter );
		treeItem->setText( 3, recus.attribute( "dreception" ).left( 10 ) );
		treeItem->setTextAlignment( 3, Qt::AlignHCenter );
		treeItem->setText( 4, recus.attribute( "etat" ) );
		treeItem->setTextAlignment( 4, Qt::AlignHCenter );
		
		pAction* action = new pAction;
		action->mPlay->setToolTip( recus.attribute( "show" ) );
		action->mDelete->setToolTip( recus.attribute( "del" ) );
		teFaxRecus->setItemWidget( treeItem, 5, action );
		// connections
		connect( action->mPlay, SIGNAL( clicked() ), this, SLOT( playClicked() ) );
		connect( action->mDelete, SIGNAL( clicked() ), this, SLOT( deleteClicked() ) );
		
		recus = recus.nextSiblingElement( "fax" );
	}
	
	/////////// ENVOYES ///////////
	// clear tree
	teFaxEnvoyes->clear();
	teFaxEnvoyes->setColumnWidth( 0, 100 );
	teFaxEnvoyes->setColumnWidth( 1, 50 );
	teFaxEnvoyes->setColumnWidth( 2, 95 );
	teFaxEnvoyes->setColumnWidth( 3, 115 );
	teFaxEnvoyes->setColumnWidth( 4, 35 );
	teFaxEnvoyes->setColumnWidth( 5, 60 );
	
	QDomElement envoyes = root.firstChildElement( "envoyes" ).firstChildElement( "fax" );
	while( !envoyes.isNull() )
	{
		QTreeWidgetItem * treeItem = new QTreeWidgetItem( teFaxEnvoyes );
		treeItem->setText( 0, envoyes.attribute( "fichier" ) );
		treeItem->setText( 1, envoyes.attribute( "pages" ) );
		treeItem->setTextAlignment( 1, Qt::AlignHCenter );
		treeItem->setText( 2, envoyes.attribute( "dest" ) );
		treeItem->setTextAlignment( 2, Qt::AlignHCenter );
		treeItem->setText( 3, envoyes.attribute( "dreception" ).left( 10 ) );
		treeItem->setToolTip( 3, envoyes.attribute( "dreception" ).left( 10 ) );
		treeItem->setTextAlignment( 3, Qt::AlignHCenter );
		treeItem->setText( 4, envoyes.attribute( "etat" ) );
		treeItem->setTextAlignment( 4, Qt::AlignHCenter );
		
		pAction* action = new pAction;
		action->mPlay->setToolTip( envoyes.attribute( "show" ) );
		action->mDelete->setToolTip( envoyes.attribute( "del" ) );
		teFaxEnvoyes->setItemWidget( treeItem, 5, action );
		// connections
		connect( action->mPlay, SIGNAL( clicked() ), this, SLOT( playClicked() ) );
		connect( action->mDelete, SIGNAL( clicked() ), this, SLOT( deleteClicked() ) );
		
		envoyes = envoyes.nextSiblingElement( "fax" );
	}
	
	pFaxResume->setEnabled( true );
}

void UIPhone::readLogin( QSettings*, bool error )
{
	if ( error )
	{
		UIMAIN->alert( "Impossible de vous identifier sur free, annulation" );
		deleteLater();
		return;
	}
	swRight->setCurrentIndex( 0 );
	on_swRight_currentChanged( 0 );
}

void UIPhone::readService( const QByteArray& buffer, bool error )
{
	if ( error )
	{
		UIMAIN->alert( QString( "An error occurs getting file: %1" ).arg( REQUESTER->freeBaseUrl().append( "https/admsrv.php" ) ) );
		//on_swRight_currentChanged( 0 );
		return;
	}
	
	// parse
	QString ba = QString::fromLatin1( buffer );
	
	QDomDocument e("telephonie");
	e.setContent( QString::fromLatin1( buffer ) );
	
	fgRestrictionSortant->setToggled( XmlReader::readPath(e, "telephonie/derange", "etat") == "true" );
	leCode->setText( XmlReader::readPath(e, "telephonie/code") );
	fgNonReponse->setToggled( XmlReader::readPath(e, "telephonie/transrep", "etat") == "true" );
	leNumeroNonReponse->setText( XmlReader::readPath(e, "telephonie/transrep", "numero") );
	leDelaiNonReponse->setText( XmlReader::readPath(e, "telephonie/transrep", "delai") );
	fgOccupation->setToggled( XmlReader::readPath(e, "telephonie/transoccup", "etat") == "true" );
	leNumeroOccupation->setText( XmlReader::readPath(e, "telephonie/transoccup", "numero") );
	fgInconditionnel->setToggled( XmlReader::readPath(e, "telephonie/transinc", "etat") == "true" );
	leNumeroInconditionnel->setText( XmlReader::readPath(e, "telephonie/transinc", "numero") );
	cbRenvoi->setCurrentIndex( XmlReader::readPath(e, "telephonie/mevo", "mode").toInt() );
	leDelaiRenvoi->setText( XmlReader::readPath(e, "telephonie/mevo", "delai") );
	fgProtectionRenvois->setToggled( XmlReader::readPath(e, "telephonie/service", "renvois") == "true" );
	fgRejetAnonyme->setToggled( XmlReader::readPath(e, "telephonie/service", "anonymes") == "true" );
	fgAbsent->setToggled( XmlReader::readPath(e, "telephonie/service", "absent") == "true" );
	fgInstance->setToggled( XmlReader::readPath(e, "telephonie/service", "instance") == "true" );
	fgRestrictionIdentite->setToggled( XmlReader::readPath(e, "telephonie/service", "identite") == "true" );
	fgOccupation_2->setToggled( XmlReader::readPath(e, "telephonie/renvoi") == "1" ); //
	
	pServices->setEnabled( true );
}

void UIPhone::on_fgParcourir_clicked()
{
	QString fichier = QFileDialog::getOpenFileName( this, "Choisissez un fichier", QDir::homePath() );
	if( !fichier.isNull() )
	{
		leFichier->setText( QDir::toNativeSeparators( fichier ) );
	}
}

void UIPhone::on_fgEnvoiFaxBtn_clicked()
{
	SendForm sending( QUrl( "https://adsls.free.fr/admin/tel/fax/tel_ulfax.pl" ) );
	sending.setReferer( "https://adsls.free.fr/admin/tel/fax/tel_fax.pl" );
	sending.addField( "id", REQUESTER->id() );
	sending.addField( "idt", REQUESTER->idt() );
	sending.addField( "destinataire", leDestinataire->text() );
	if( fgMasquerNumero->toggled() )
		sending.addField( "masque", "Y" );
	if( fgRapportMail->toggled() )
		sending.addField( "email_ack", "1" );
	if( !leFichier->text().isEmpty() )
		sending.addFile( "document", leFichier->text() );
	
	QNetworkReply * reply = sending.post( manager );
	connect( reply, SIGNAL( finished() ), this, SLOT( faxSendingFinished() ) );
}

void UIPhone::faxSendingFinished()
{
	QNetworkReply * rep = qobject_cast<QNetworkReply*>(sender());
	if(rep)
	{
		UIMAIN->alert(QString::fromUtf8("Fax envoyé"), true, true);
		
		rep->deleteLater();
	}
}

void UIPhone::on_fgAjoutAdresse_clicked()
{
	QString mPost = QString( "https://adsls.free.fr/admin/tel/fax/tel_managenotif_fax.pl?action=add&email=%1" )
					.arg( leAdresse->text().replace("@", "%40") );
	leAdresse->setText( "" );
	
	REQUESTER->requestUrl( mPost );
	UIMAIN->alert(QString::fromUtf8("Adresse ajoutée"), true, true);
	
	on_swRight_currentChanged( 5 );
}

void UIPhone::on_fgServicesEnregistrer_clicked()
{
	QString mPost = QString( "admin/tel/adminservice_valid.pl?absent=%1&derange=%2&appsort=%3&"
		"identite=%4&renvoi=%5&anonymes=%6&transoccup=%7&occup=%8&instance=%9&"
		"transinc=%10&incon=%11&transrep=%12&nonrep=%13&delai=%14&mevo_mode=%15&"
		"mevo_delai=%16" )
		.arg( fgAbsent->toggled() ? "absent" : "" )
		.arg( fgRestrictionSortant->toggled() ? "derange" : "" )
		.arg( leCode->text() )
		.arg( fgRestrictionIdentite->toggled() ? "identite" : "" )
		.arg( fgProtectionRenvois->toggled() ? "renvoi" : "" )
		.arg( fgRejetAnonyme->toggled() ? "anonymes" : "" )
		.arg( fgOccupation->toggled() ? "transoccup" : "" )
		.arg( leNumeroOccupation->text() )
		.arg( fgInstance->toggled() ? "instance" : "" )
		.arg( fgInconditionnel->toggled() ? "transinc" : "" )
		.arg( leNumeroInconditionnel->text() )
		.arg( fgNonReponse->toggled() ? "transrep" : "" )
		.arg( leNumeroNonReponse->text() )
		.arg( leDelaiNonReponse->text() )
		.arg( cbRenvoi->currentIndex() )
		.arg( leDelaiRenvoi->text() );
	mPost.prepend( REQUESTER->freeSSLBaseUrl() );
	// post data
	REQUESTER->requestUrl( mPost );
	
	UIMAIN->alert( QString::fromUtf8( "Modifications enregistrées" ) );
	// reload data
	on_swRight_currentChanged( swRight->currentIndex() );
}

void UIPhone::readNotification( const QByteArray& buffer, bool error )
{
	if ( error )
	{
		UIMAIN->alert( QString( "An error occurs getting file: %1" ).arg( REQUESTER->freeBaseUrl().append( "notification_tel.php" ) ) );
		return;
	}
	
	// clear
	twMessages->clear();
	
	// parse
	QDomDocument e( "FreeNotifications" );
	e.setContent( buffer );
	QDomElement root = e.firstChildElement( "messagerie" );
	
	bool hasMessage = false;
	for(int i = 1;!root.firstChildElement( QString("message%1").arg( i ) ).isNull();i++)
	{
		hasMessage = true;
		
		QDomElement element = root.firstChildElement( QString("message%1").arg( i ) ).toElement();
		
		QTreeWidgetItem* it = new QTreeWidgetItem( twMessages );
		it->setText( 0, element.attribute( "type" ).section( ' ', 0, 0 ) );
		it->setText( 1, element.attribute( "provenance" ) );
		it->setTextAlignment( 1, Qt::AlignHCenter );
		it->setText( 2, element.attribute( "date" ) );
		it->setTextAlignment( 2, Qt::AlignHCenter );
		it->setText( 3, QString( "%1s" ).arg( element.attribute( "duree" ) ) );
		it->setTextAlignment( 3, Qt::AlignHCenter );
		it->setTextAlignment( 4, Qt::AlignHCenter );
		
		pAction* action = new pAction;
		action->mPlay->setToolTip( element.attribute( "ecoute" ) );
		action->mDelete->setToolTip( element.attribute( "effacer" ) );
		twMessages->setItemWidget( it, 4, action );
		// connections
		connect( action->mPlay, SIGNAL( clicked() ), this, SLOT( playClicked() ) );
		connect( action->mDelete, SIGNAL( clicked() ), this, SLOT( deleteClicked() ) );
	}
	if ( !hasMessage )
	{
		QTreeWidgetItem* it = new QTreeWidgetItem( twMessages );
		it->setFirstColumnSpanned( true );
		it->setTextAlignment( 0, Qt::AlignHCenter );
		it->setText( 0, "Pas de nouveau message" );
	}
	else
	{
		twMessages->setColumnWidth( 0, 85 );
		twMessages->setColumnWidth( 1, 90 );
		twMessages->setColumnWidth( 2, 142 );
		twMessages->setColumnWidth( 3, 40 );
		twMessages->setColumnWidth( 4, 90 );
	}
	
	leNotification1->setText( XmlReader::readPath(e, "messagerie/notif1") );
	leNotification2->setText( XmlReader::readPath(e, "messagerie/notif2") );
	leNotification3->setText( XmlReader::readPath(e, "messagerie/notif3") );
	leNotification4->setText( XmlReader::readPath(e, "messagerie/notif4") );
	
	cbNotification1->setCurrentIndex( XmlReader::readPath(e, "messagerie/notif1", "type").toInt() );
	cbNotification2->setCurrentIndex( XmlReader::readPath(e, "messagerie/notif2", "type").toInt() );
	cbNotification3->setCurrentIndex( XmlReader::readPath(e, "messagerie/notif3", "type").toInt() );
	cbNotification4->setCurrentIndex( XmlReader::readPath(e, "messagerie/notif4", "type").toInt() );
	
	pMessagerie->setEnabled( true );
}

void UIPhone::playClicked()
{
	fgLabel* label = qobject_cast<fgLabel*>( sender() );
	if ( label )
	{
		QString file = label->toolTip();
		if( !file.endsWith(".au") )
		{
			misc::openUrl( file );
		}
		else
		{
			DownloadMessageBox db( label->toolTip() );
			QEventLoop loop;
			connect( &db, SIGNAL( terminated() ), &loop, SLOT( quit() ) );
			loop.exec();
		}
	}
}

void UIPhone::deleteClicked()
{
	fgLabel* label = qobject_cast<fgLabel*>( sender() );
	if ( label )
	{
		REQUESTER->requestUrl( label->toolTip() );
		on_swRight_currentChanged( swRight->currentIndex() );
	}
}

void UIPhone::on_fgMessagerieEnregistrer_clicked()
{
	QString mPost = QString( "admin/tel/notification_tel_valid.pl?type1=%1&type2=%2&"
		"type3=%3&type4=%4&email1=%5&email2=%6&email3=%7&email4=%8&notel=0&submit=Valider" )
		.arg( cbNotification1->currentIndex() )
		.arg( cbNotification2->currentIndex() )
		.arg( cbNotification3->currentIndex() )
		.arg( cbNotification4->currentIndex() )
		.arg( leNotification1->text() )
		.arg( leNotification2->text() )
		.arg( leNotification3->text() )
		.arg( leNotification4->text() );
	mPost.prepend( REQUESTER->freeSSLBaseUrl() );
	// post data
	REQUESTER->requestUrl( mPost );
	
	UIMAIN->alert( QString::fromUtf8( "Modifications enregistrées" ) );
	// reload data
	on_swRight_currentChanged( swRight->currentIndex() );
}

void UIPhone::on_fgAnnuaireRechercher_clicked()
{
	if ( leNumFreebox->text().count() == 10 )
	{
		QString mPost = QString( "annu/inverse.php5?tel=%1" ).arg( leNumFreebox->text() );
		mPost.prepend( REQUESTER->freeGoBaseUrl() );
		REQUESTER->requestUrl( this, "readAnnuaire", mPost );
		pAnnuaire->setEnabled( false );
	}
	else
	{
		if ( !leNom->text().isEmpty() &&
			( !leDept->text().isEmpty() || !leCP->text().isEmpty() || !leVille->text().isEmpty() ) )
		{
			QString mPost = QString( "annu/annuaire.php5?lname=%1&fname=%2&dep=%3&cp=%4&town=%5" )
				.arg( leNom->text() )
				.arg( lePrenom->text() )
				.arg( leDept->text() )
				.arg( leCP->text() )
				.arg( leVille->text() );
			mPost.prepend( REQUESTER->freeGoBaseUrl() );
			REQUESTER->requestUrl( this, "readAnnuaire", mPost );
			pAnnuaire->setEnabled( false );
		}
		else
			UIMAIN->alert( QString::fromUtf8( "Vous devez entrer obligatoirement :\nun nom et soit un département, soit un code postal, soit une ville." ) );
	}
}

void UIPhone::readAnnuaire( QSettings* settings, bool error )
{
	if ( error )
	{
		UIMAIN->alert( QString::fromUtf8( "Une erreur est apparue à la réception du résultat" ) );
		return;
	}
	
	pfgResultat->setVisible( true );
	
	// clear textedit
	teResultat->clear();
	// read messages
	int size = settings->beginReadArray( "ANNUAIRE" );
	if ( size > 0 )
	{
		teResultat->insertHtml( "<table align=\"center\" cellpadding=\"0\" border=\"0\" cellspacing=\"0\" width=\"100%\">" );
		for ( int i = 0; i < size; i++ )
		{
			settings->setArrayIndex( i );
			// fill infos
			teResultat->insertHtml( "<tr>" );
			teResultat->insertHtml( QString( "<td>%1</td>" ).arg( Qt::escape( QString::fromUtf8( settings->value( "NOM" ).toByteArray() ) ) ) );
			teResultat->insertHtml( QString( "<td>%1</td>" ).arg( Qt::escape( QString::fromUtf8( settings->value( "NUMERO" ).toByteArray() ) ) ) );
			teResultat->insertHtml( "</tr>" );
			teResultat->insertHtml( "<tr>" );
			teResultat->insertHtml( QString( "<td>%1</td>" ).arg( Qt::escape( QString::fromUtf8( settings->value( "ADRESSE" ).toByteArray() ) ) ) );
			teResultat->insertHtml( QString( "<td>%1</td>" ).arg( Qt::escape( QString::fromUtf8( settings->value( "VILLE" ).toByteArray() ) ) ) );
			teResultat->insertHtml( "</tr>" );
			teResultat->insertHtml( "<tr><hr /></tr>" );
		}
		settings->endArray();
		teResultat->insertHtml( "</table>" );
	}
	else
		teResultat->insertHtml( QString( "<center>%1</center>" ).arg( QString::fromUtf8( settings->value( "ERROR" ).toByteArray() ) ) );
	
	pAnnuaire->setEnabled( true );
}
