/********************************************************************************************************
* PROGRAM      : FreeGo4
* DATE - TIME  : jeudi 24 aot 2006 - 22h15
* AUTHOR       : Azevedo Filipe aka Nox PasNox ( pasnox at gmail dot com )
* FILENAME     : UIPhone.h
* LICENSE      : GPL
* COMMENTARY   : 
********************************************************************************************************/
#ifndef UIPHONE_H
#define UIPHONE_H

#include "ui_UIPhone.h"
#include "SendForm.h"

#include <QPointer>
#include <QMessageBox>
#include <QTemporaryFile>

class QSettings;

class pAction : public QWidget
{
	Q_OBJECT

public:
	pAction( QWidget* = 0 );

	fgLabel* mPlay;
	fgLabel* mDelete;
};

class DownloadMessageBox : public QObject
{
	Q_OBJECT

public:
	DownloadMessageBox( const QString &, QObject* = 0);

public slots:
	void onFinished();

signals:
	void terminated();

private:
	static QNetworkAccessManager manager;
};

class UIPhone : public fgDialog, public Ui::UIPhone
{
	Q_OBJECT

public:
	static UIPhone* self( QWidget* parent = 0 );

protected:
	void showEvent( QShowEvent* event );

private:
	UIPhone( QWidget* parent = 0 );
	static QPointer<UIPhone> mSelf;
	bool mInit;
	QNetworkAccessManager * manager;

private slots:
	void on_swRight_currentChanged( int id );
	void readLogin( QSettings* settings, bool error );
	void readService( const QByteArray& buffer, bool error );
	void on_fgServicesEnregistrer_clicked();
	void readNotification( const QByteArray& buffer, bool error );
	void readEnvoyesRecus( const QByteArray& buffer, bool error );
	void readNotifFax( const QByteArray& buffer, bool error );
	void playClicked();
	void deleteClicked();
	void on_fgMessagerieEnregistrer_clicked();
	void on_fgAnnuaireRechercher_clicked();
	void readAnnuaire( QSettings* settings, bool error );
	void on_fgParcourir_clicked();
	void on_fgEnvoiFaxBtn_clicked();
	void on_fgAjoutAdresse_clicked();
	void faxSendingFinished();
};

#endif // UIPHONE_H
